# Uranai

A library for solving **Supervised Learning**  (***regression*** & ***classification***) problems.

## Installation

Add this line to your application's Gemfile:
```ruby
gem 'uranai'
```
And then execute:
```shell
$ bundle
```
Or install it yourself as:
```shell
$ gem install uranai
```

## Linear Regression Example:

```ruby
# Instantiates a linear regression instance.
linear_regression = Uranai::LinearRegression.new("data.csv")

# Computes cost (using cost function) with `default_theta`.
initial_cost = linear_regression.compute_cost

# Computes cost (using cost function) with custom theta.
custom_cost = linear_regression.compute_cost(theta: [0.5, 0.5])

# Finds fitting parameters.
fitting_params = linear_regression.fitting_params

# Predicts the result from given data.
result = fitting_params.predict([3.5])
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake test` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/teerawat1992/uranai.

## TODO

- [x] Linear Regression
- [ ] Logistic Regression
- [ ] Neural Networks
- [ ] Support Vector Machines (SVMs)
